#include <config.h>
#include <distributions/Distribution.h>

using std::vector;
using std::string;

Distribution::Distribution(string const &name, unsigned int npar)
  : _name(name), _npar(npar)
{
}

Distribution::~Distribution()
{
}

string const &Distribution::name() const
{
  return _name;
}

SArray const * 
Distribution::lowerBound(vector<SArray const *> const &parameters) const
{
  return parameters.size() ==  _npar + 2 ? parameters[_npar] : 0;
}

SArray const *
Distribution::upperBound(vector<SArray const *> const &parameters) const
{
  return parameters.size() == _npar + 2 ? parameters[_npar + 1] : 0;
}

bool
Distribution::checkParameterLength(vector<SArray const *> const &parameters) const
{
  return parameters.size() == _npar + 2;
}
