#ifndef FUNC_ADD_H_
#define FUNC_ADD_H_

#include <functions/ScalarArgScalarFunc.h>

/**
 * The Add function implements the infix operator "+" in the BUGS language.
 * The expression a + b + c is broken down into ((a + b) + c), so two
 * separate calls to Add are made.
 * @short Sum of two scalars
 * <pre>
 * y <- a + b
 * </pre>
 */
class Add:public ScalarArgScalarFunc
{
public:
  Add ();
  double evaluate (std::vector < SArray const *>const &args) const;
};

#endif /* FUNC_ADD_H_ */
