#ifndef FUNC_DIVIDE_H_
#define FUNC_DIVIDE_H_

#include <functions/ScalarArgScalarFunc.h>

/**
 * The Divide function implements the infix operator "/" in the BUGS 
 * language
 * @short Ratio of two scalars
 * <pre>
 * y <- a/b
 * y = a/b for b != 0
 * </pre>
 */
class Divide:public ScalarArgScalarFunc
{
public:
  Divide ();
  double evaluate (std::vector <SArray const *> const &args) const;
  bool checkParameterValue (std::vector <SArray const *> const &args) const;
};

#endif /* FUNC_DIVIDE_H_ */
