#include <config.h>
#include <functions/Identity.h>
#include <sarray/SArray.h>

#include <stdexcept>

using
  std::vector;

Identity::Identity ():Function ("identity", 1)
{
}

void
Identity::evaluate (SArray & value, vector <SArray const *>const &args) const
{
  value.setValue (args[0]->value(), args[0]->length());
}

bool
Identity::checkDim (SArray const &value,
		    vector <SArray const *> const &args) const
{
  return (value.dim(true) == args[0]->dim(true));
}

Index Identity::dim (std::vector <SArray const *> const &args) const
{
  return args[0]->dim(true);
}
