#ifndef IDENTITY_H_
#define IDENTITY_H_

#include <functions/Function.h>

/** 
 * @short Identity function
 * The identity function copies the value of its argument. Arrays may
 * be copied if their dimensions conform
 * <pre>
 * y <- x
 * </pre>
 */
class Identity:public Function
{
public:
  Identity ();

  void evaluate (SArray & value,
		 std::vector <SArray const *> const &args) const;
  bool checkDim (SArray const &value,
		 std::vector <SArray const *> const &args) const;
  Index dim (std::vector <SArray const *> const &args) const;
};

#endif /* IDENTITY_H_ */
