#include <config.h>
#include <functions/InProd.h>
#include <sarray/SArray.h>

using std::vector;

InProd::InProd () : ScalarFunc ("inprod", 2)
{
}

double
InProd::evaluate (vector <SArray const *> const &args) const
{
  double const *arg1 = args[0]->value ();
  double const *arg2 = args[1]->value ();
  long len = args[0]->length ();
  double svalue = 0;
  for (long i = 0; i < len; i++)
    {
      svalue += arg1[i] * arg2[i];
    }
  return svalue;
}

bool
  InProd::checkDim (SArray const &value,
		    vector < SArray const *>const &args) const
{
  if (value.length () != 1)
    return false;
  return (args[0]->dim (true) == args[1]->dim (true));
}
