#include <config.h>
#include <functions/Inverse.h>
#include <matrix/matrix.h>
#include <sarray/SArray.h>

Inverse::Inverse ():Function ("inverse", 1)
{
}

void
Inverse::evaluate (SArray & value, std::vector <SArray const *> const &args) const
{
  int n = args[0]->dim (true)[0];
  int N = args[0]->length ();
  double *y = new double[N];
  inverse (y, args[0]->value (), n, false);
  value.setValue (y, N);
  delete y;
}

bool
  Inverse::checkDim (SArray const &value,
		     std::vector < SArray const *> const &args) const
{
  Index const &dim = value.dim (true);
  if (dim.length () != 2 || dim[0] != dim[1])
    return false;
  return (dim == args[0]->dim (true));
}

Index Inverse::dim (std::vector <SArray const *> const &args) const
{
  return args[0]->dim(true);
}
