#include <config.h>
#include <functions/LogDet.h>
#include <matrix/matrix.h>
#include <sarray/SArray.h>

LogDet::LogDet ()
  : ScalarFunc ("logdet", 1)
{
}

double
LogDet::evaluate (std::vector <SArray const *> const &args) const
{
  return logdet (args[0]->value (), args[0]->dim (true)[0]);
}

bool
LogDet::checkDim (SArray const &value,
		  std::vector <SArray const *> const &args) const
{
  if (value.length () != 1)
    return false;
  Index const &dim = args[0]->dim (true);
  return (dim.length () == 2) && (dim[0] == dim[1]);
}

/* FIXME: we need a checkParameterValue function */

