#include <config.h>
#include <functions/LogFact.h>
#include <sarray/SArray.h>

#include <Rmath.h>

LogFact::LogFact ()
  : ScalarArgScalarFunc ("logfact", 1)
{
}

double
LogFact::evaluate (std::vector < SArray const *>const &args) const
{
  return lgammafn (*args[0]->value() + 1);
}

bool 
LogFact::checkParameterValue (std::vector < SArray const *>const &args) const
{
  return *args[0]->value()  > -1;
}
