#include <config.h>
#include <functions/Logit.h>
#include <sarray/SArray.h>

#include <cmath>

Logit::Logit ():ScalarArgScalarFunc ("logit", 1)
{
}

double
Logit::evaluate (std::vector < SArray const *>const &args) const
{
  double arg = *args[0]->value ();
  return log (arg / (1 - arg));
}

bool
Logit::checkParameterValue (std::vector < SArray const *>const &args) const
{
  double arg = *args[0]->value ();
  return (arg >= 0 && arg <= 1);
}
