#include <config.h>
#include <functions/Max.h>
#include <sarray/SArray.h>

#include <algorithm>

using std::max_element;
using std::max;

Max::Max ()
  : Function ("max", 0)
{
}

void
Max::evaluate (SArray &value, std::vector < SArray const *>const &args) const
{
  double ans;
  for (unsigned int i = 0; i < args.size(); ++i) {
    double const *argi = args[i]->value ();
    long len = args[i]->length ();
    double maxi = *max_element(argi, argi + len);
    if (i == 0) {
      ans = maxi;
    }
    else {
      ans = max(ans, maxi);
    }
  }
  value.setValue(&ans, 1);
}

bool
Max::checkDim (SArray const &value, std::vector < SArray const *>const &args) 
  const
{
  return (value.length () == 1);
}

Index Max::dim (std::vector <SArray const *> const &args) const
{
  return Index(1);
}
