#include <config.h>
#include <functions/Mean.h>
#include <sarray/SArray.h>

Mean::Mean ()
  : ScalarFunc ("mean", 1)
{
}

double
Mean::evaluate (std::vector < SArray const *>const &args) const
{
  double const *arg1 = args[0]->value ();
  long len = args[0]->length ();
  double svalue = 0;
  for (long i = 0; i < len; i++)
    {
      svalue += arg1[i];
    }
  svalue /= len;
  return svalue;
}

bool
Mean::checkDim (SArray const &value, std::vector < SArray const *>const &args) 
  const
{
  return (value.length () == 1);
}
