#include <config.h>
#include <functions/Probit.h>
#include <sarray/SArray.h>

#include <Rmath.h>


Probit::Probit ()
  : ScalarArgScalarFunc ("probit", 1)
{
}

double
Probit::evaluate (std::vector < SArray const *>const &args) const
{
  double p = *(args[0]->value ());
  return qnorm5 (p, 0, 1, 0, 0);
}

bool
Probit::checkParameterValue (std::vector < SArray const *>const &args) const
{
  double p = *(args[0]->value ());
  return (p > 0 && p < 1);
}
