#ifndef FUNC_SD_H_
#define FUNC_SD_H_

#include <functions/ScalarFunc.h>

/**
 * @short Standard deviation function
 * SD calculates the standard deviation of the elements of an array.
 * The array must have at least 2 elements.
 * @see mean
 * <pre>
 * y <- sd(x[])
 * </pre>
 */
class SD : public ScalarFunc
{
public:
  SD ();
  double evaluate (std::vector <SArray const *> const &args) const;
  bool checkDim (SArray const &value,
		 std::vector <SArray const *> const &args) const;
};

#endif /* FUNC_SD_H_ */
