#ifndef SCALAR_ARG_SCALAR_FUNC_H_
#define SCALAR_ARG_SCALAR_FUNC_H_

#include <functions/ScalarFunc.h>

/** 
 * ScalarArgScalarFunc provides a common checkDim function for 
 * scalar valued functions whose arguments are also scalars
 * @short Scalar argument functions
 */
class ScalarArgScalarFunc : public ScalarFunc
{
public:
  ScalarArgScalarFunc (std::string const &name, unsigned int npar);
  /**
   * Implementation of checkDim
   */
  bool checkDim (SArray const &value,
		 std::vector < SArray const *>const &args) const;
};

#endif /* SCALAR_ARG_SCALAR_FUNC_H_ */
