#include <config.h>
#include <functions/Sqrt.h>
#include <sarray/SArray.h>

#include <cmath>

Sqrt::Sqrt ():ScalarArgScalarFunc ("sqrt", 1)
{
}

double
Sqrt::evaluate (std::vector < SArray const *>const &args) const
{
  double arg = *(args[0]->value ());
  return sqrt (arg);
}

bool
Sqrt::checkParameterValue (std::vector < SArray const *>const &args) const
{
  double arg = *(args[0]->value ());
  return (arg >= 0);
}
