#include <config.h>
#include <functions/Sum.h>
#include <sarray/SArray.h>

Sum::Sum () : ScalarFunc ("sum", 1)
{
}

double
Sum::evaluate (std::vector < SArray const *>const &args) const
{
  double const *arg1 = args[0]->value ();
  long len = args[0]->length ();
  double value = 0;
  for (long i = 0; i < len; i++)
    {
      value += arg1[i];
    }
  return value;
}

bool
Sum::checkDim (SArray const &value, std::vector < SArray const *>const &args) 
  const
{
  return value.length () == 1;
}
