#include <config.h>
#include <graph/OffsetNode.h>

using std::vector;

OffsetNode::OffsetNode(Range const &range, 
		       std::vector<SubSetIndex> const &index)
  : DeterministicNode(Index(1)), _index(index), _range(range), 
    _ndim(range.ndim(false))
{
  for (unsigned int i = 0; i < _ndim; ++i) {
    Node *parent = _index[i].node();
    if (parent)
      this->addParent(parent);
  }
}
	
OffsetNode::~OffsetNode()
{
}

void OffsetNode::forwardSample()
{
  Index index(_ndim);
  for (unsigned int i = 0; i < _ndim; i++) {
    index[i] = _index[i].value();  
  }
  double value = (double) _range.leftOffset(index);
  data.setValue(&value, 1);
}

