#ifndef SUBSET_INDEX_H_
#define SUBSET_INDEX_H_

/* 
   The indices that define a SubSetNode can be either a fixed value
   (long integer) or a Node. We need a special class to 
   represent both types.
*/

/* FIXME: Node was originally const, but I had to change this.
   Should parents of a node always be const?
*/

#include <vector>
class Node;
class Index;

class SubSetIndex {
	long _value;
	Node *_node;	
 public:
	SubSetIndex();
	SubSetIndex(long value);
	SubSetIndex(Node *node);

	long value() const;
	Node *node() const;

	static Index dim(std::vector<SubSetIndex> const &lower, 
			 std::vector<SubSetIndex> const &upper);
	static bool checkLimits(std::vector<SubSetIndex> const &lower,
				std::vector<SubSetIndex> const &upper);
};
	
#endif /* SUBSET_INDEX_H_ */
