#ifndef CONJUGATE_BETA_H_
#define CONJUGATE_BETA_H_

#include <sampler/ConjugateSampler.h>

/**
 * Conjugate sampler for the beta distribution
 *
 * A conjugate beta samplers can be created for a Stochastic node
 * "snode" if its informative children are all stochastic nodes with
 * either a binomial or a Bernoulli distribution with snode as the
 * probability parameter. In the case of binomial children, the sample
 * size parameter must not depend on snode
 */
class ConjugateBeta : public ConjugateSampler {
 public:
  ConjugateBeta(StochasticNode *snode);
  ~ConjugateBeta();
  
  static bool canSample(StochasticNode const *snode);
  void update();
};

#endif /* CONJUGATE_BETA_H_ */
