#include <sampler/GibbsFactory.h>
#include <sampler/GibbsSampler.h>
#include <graph/StochasticNode.h>
#include <sampler/Sampler.h>

using std::set;
using std::list;


void GibbsFactory::makeSampler(set<StochasticNode*> &nodes, 
			       list<Sampler*> &samplers) const
{
  for (set<StochasticNode*>::iterator p(nodes.begin()); p != nodes.end(); ++p)
    {
      if (canSample(*p)) {
	samplers.push_back(makeGibbsSampler(*p));
	nodes.erase(p);
      }
    }
}
