#include <config.h>
#include <sampler/GibbsSampler.h>
#include <graph/StochasticNode.h>
#include <graph/DeterministicNode.h>

#include <Rmath.h>

#include <vector>
#include <set>

using std::vector;
using std::set;

void GibbsSampler::classifyChildren(StochasticNode const *node,
				    vector<StochasticNode*> &stoch_nodes,
				    vector<DeterministicNode*> &dtrm_nodes)
{
  set<StochasticNode const *> nodeset;
  nodeset.insert(node);
  Sampler::classifyChildren(nodeset, stoch_nodes, dtrm_nodes);
}

GibbsSampler::GibbsSampler(StochasticNode *node)
  : Sampler(vector<StochasticNode *>(1, node)), _node(node)
{
}

void GibbsSampler::setValue(double const *value, long length)
{
  _node->data.setValue(value, length);
  vector<DeterministicNode*> const &dc = deterministicChildren();
  for (vector<DeterministicNode*>::const_iterator i(dc.begin()); 
     i != dc.end(); ++i)
    {
      (*i)->forwardSample();
    }
}

StochasticNode *GibbsSampler::node()
{
  return _node;
}
