#include <config.h>
#include <sarray/Index.h>
#include <stdexcept>

using std::out_of_range;

Index::Index(unsigned int length)
{
  _length = length;
  _index = new long[length];
  for (unsigned int i = 0; i < length; i++) {
    _index[i] = 1;
  }
}

Index::Index(Index const &orig)
{
  _length = orig._length;
  _index = new long[_length];
  for (unsigned int i = 0; i < _length; i++) {
    _index[i] = orig._index[i];
  }
}

Index::~Index()
{
  delete [] _index;
}

Index &Index::operator=(Index const &rhs)
{
  if (rhs._length != _length) {
    _length = rhs._length;
    delete [] _index;
    _index = new long[_length];
  }
  for (unsigned int i = 0; i < _length; i++) {
    _index[i] = rhs._index[i];
  }
  return *this;
}

unsigned int Index::length() const
{
  return _length;
}

bool Index::operator==(Index const &other) const
{
  if (_length != other._length) {
    return false;
  }
  else {
    for(unsigned int i = 0; i < _length; i++) {
      if (_index[i] != other._index[i])
	return false;
    }
  }
  return true;
}

bool Index::operator!=(Index const &other) const
{
  return !operator==(other);
}


long &Index::operator[](unsigned int i)
{
  if (i >= _length) {
    throw out_of_range("Attempt to access nonexistent element of Index");
  }

  return _index[i];
}

long Index::operator[](unsigned int i) const
{
  if (i >= _length) {
    throw out_of_range("Attempt to access nonexistent element of Index");
  }

  return _index[i];
}

int indexComp(Index const &i1, Index const &i2)
{
  /* 
     Comparison function for Indices based on strcmp
  */
  
  int len1 = i1.length();
  int len2 = i2.length();
  int len = len1 < len2 ? len1 : len2;
  
  for (int i = 0; i < len; i++) {
    if (i1[i] < i2[i]) {
      return -1;
    }
    else if (i1[i] > i2[i]) {
      return 1;
    }
  }

  if (len1 > len2) {
    return 1;
  }
  else if (len1 < len2) {
    return -1;
  }
  return 0;
}
